## pyferret 7.6.0~beta

=== debian/changelog ===
pyferret (7.6.0~beta-2) unstable; urgency=medium

  * Fix FTBFS due to missing symbol in patch. Closes: #960799

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 18 May 2020 18:05:39 +0100

pyferret (7.6.0~beta-1) unstable; urgency=medium

  * New upstream release
  * Fix FTBFS with gcc10 / gfortran10. Closes: #957721
  * Add first autopkgtest framework
  * B-D on python3-all-dev for multiple python3 versions
  * Fix DEP-5 Formatting error in d/copyright

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 03 May 2020 11:39:02 +0100

pyferret (7.5.0-5) unstable; urgency=medium

  * Fix build with multiple python versions

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 06 Mar 2020 15:18:51 +0000

pyferret (7.5.0-4) unstable; urgency=medium

  * Standards-Version: 4.5.0
  * Move from --with python3 to using dh-sequence-python3

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 03 Mar 2020 20:23:02 +0000

pyferret (7.5.0-3) unstable; urgency=medium

  * Use debhelper-compat (=12)
  * Use https homepage
  * Fix FTBFS with python3.8 and pango from experimental. Thanks
    to Matthias Klose. Closes: #950134

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 03 Feb 2020 18:13:37 +0000

=== debian/control ===
Source: pyferret
Standards-Version: 4.5.0
Homepage: https://ferret.pmel.noaa.gov/Ferret/documentation/pyferret
Vcs-Browser: https://salsa.debian.org:/science-team/pyferret
Vcs-Git: https://salsa.debian.org:/science-team/pyferret.git
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Section: science
Priority: optional
X-Python3-Version: >= 3.6
Build-Depends: debhelper-compat (= 12),
 dh-sequence-python3,
 gfortran | fortran-compiler,
 pkg-config,
 csh,
 libreadline-dev, 
 libcurl4-openssl-dev | libcurl-dev, 
 libncurses-dev, 
 libnetcdf-dev (>= 4.3.0),
 libnetcdff-dev,
 libxpm-dev, 
 libxt-dev, 
 libcairo2-dev, 
 libpango1.0-dev,
 python3-all-dev,
 python3-numpy,
 python3-future,
 ferret-vis

Package: python3-ferret
Architecture: any
Section: python
Depends: ${misc:Depends}, ${shlibs:Depends}, ferret-vis, ${python3:Depends}, python3-future
Recommends: ferret-datasets, python3-scipy, python3-pyshp
Description: Python3 wrapper for the Ferret visualization and analysis environment,
 Ferret is an interactive computer visualization and analysis environment
 designed to meet the needs of oceanographers and meteorologists analyzing
 large and complex gridded data sets. It can transparently access extensive
 remote Internet data bases using OPeNDAP (formerly known as DODS)
 .
 This is the Python3 wrapper for Ferret

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# magic debhelper rule
%:
	dh $@ 

# To aid reproducible builds
LC_ALL=C
export LC_ALL

ARCH:=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR:=/usr/lib/$(ARCH)
INSTALLDIR:=$(CURDIR)/debian/tmp

# FC set to f77 by default in make
# Read default compiler name unless FC is actually set
ifeq ($(FC),f77)
  FC:=$(shell basename $(shell readlink /etc/alternatives/f95))
endif

# Version of Fortran compiler
FORT_VER:=$(shell basename $(shell readlink /usr/bin/$(FC)))

PY3:=$(shell py3versions -s)

override_dh_auto_build:
	cp debian/platform_specific.mk.debian.$(FORT_VER) platform_specific.mk.debian
	cp debian/ef_utility/platform_specific.mk.debian.$(FORT_VER) external_functions/ef_utility/platform_specific.mk.debian
	sed -e 's%@ARCH@%${ARCH}%' \
                -e 's%@LIBDIR@%${LIBDIR}%' \
		-e 's%@CURDIR@%${CURDIR}%' \
                -e 's%@INSTALLDIR@%${INSTALLDIR}%' \
                < debian/site_specific.mk.in > site_specific.mk
	cp site_specific.mk external_functions/ef_utility

override_dh_auto_install:
	# Build and install 
	# Horrible hack breaks The Debian Way. I'm doing the build in the 'install' phase, as i'm installing into debian/tmp
	# Doing it any earlier, and dh_prep will remove debian/tmp. 
	# This means I'm also doing 'test' after the Install, not between during make & install. gack.
	for p in $(PY3) ; do \
		mkdir -p $(INSTALLDIR)/lib/$$p ; \
		cp $(CURDIR)/install/lib/$$p/site-packages//pyferret/libpyferret.cpython-$$l-$(ARCH).so \
			$(INSTALLDIR)/lib/$$p ; \
		n=`echo $$p | tr -d 'python' | tr -d '.' ` ; \
                ln -s  $(CURDIR)/install/lib/$$p/site-packages//pyferret/libpyferret.cpython-$$n-$(ARCH).so \
                   $(INSTALLDIR)/lib/$$p/libpyferret.so ; \
		mkdir -p debian/tmp-$$p ; \
		$(MAKE) HOSTTYPE=debian PYTHON_EXE=$$p INSTALLDIR=debian/tmp-$$p clean all install ; \
		done
	find debian \( -name '*.pyo' -o -name '*.pyc' \) -delete
	find debian -type d -name __pycache__ -delete
	dh_numpy3
	@echo "Now doing bench tests"
	ln -s debian/pyferret3  $(INSTALLDIR)/lib/$(shell py3versions -d)/pyferret
	# First build necessary files
	for p in  $(PY3) ; do \
		sed -e 's%@ARCH@%${ARCH}%' \
                -e 's%@LIBDIR@%${LIBDIR}%' \
		-e 's%@CURDIR@%${CURDIR}%' \
                -e "s%@PYTHON@%$$p%" \
                < debian/site_specific.mk.in > site_specific.mk ; \
		PATH=$(INSTALLDIR)/lib/$$p:$(PATH) PYTHONPATH=$(INSTALLDIR)/lib/$$p/site-packages \
		echo "IGNORING TESTS" ;  \
		done

override_dh_auto_test:
	@echo "Dummy test, to avoid calling make. Do test later"

override_dh_auto_clean:
	# use system xpm.h, not supplied ones
	rm -f fer/gui/xpm*.h
	rm -rf ./build ./install
	find . -type l  -delete 
	find . -name '*.o' -o -name '*.so'  -delete
	[ ! -f platform_specific_flags.mk.debian ]  || $(MAKE)  clean HOSTTYPE=debian

=== debian/tests/control ===
Test-Command: set -e
 ; for py in $(py3versions -r 2>/dev/null)
 ; do cd "$AUTOPKGTEST_TMP"
 ; echo "Testing with $py:"
 ; $py -c "import pyferret"
 ; done
Depends: python3-ferret

## pyferret 7.6.3

=== external_functions/Makefile ===
#
# Top level Makefile for Ferret External Functions
#
# September 09 1998
# Jonathan Callahan
#
# ACM 1/2002  add fft directory back in: lsl_lowpass, inverse fcn.
# ACM 4/2006  link all functions that are distributed statically; the
#             directories below compile only example functions, functions
#             under development, or used locally by PMEL/TMAP (e.g.romea fcns)
 
#
# Site-specific defines
#
include ../site_specific.mk

#
# include platform specific definitions of:
#       CC, FC, RANLIB, CFLAGS, FFLAGS, PPLUS_FFLAGS
#
include ../platform_specific.mk.$(BUILDTYPE)

#
# Macro Definitions
#

# DIRS = ef_utility
DIRS = ef_utility contributed decimate examples fft las statistics stringfcns
MOREDIRS = cmprsi_by extrema featurecollections gridding tax_times

#
# Targets
#

.PHONY : all
all: optimized

.PHONY : optimized
optimized:
	$(MAKE) "CFLAGS = $(CFLAGS) -O" "FFLAGS = $(FFLAGS) -O" build

.PHONY : debug
debug:
	$(MAKE) "CFLAGS = $(CFLAGS) -O0 -g" "FFLAGS = $(FFLAGS) -O0 -g" build

.PHONY: build
build:
	for i in $(DIRS) ; do \
            if ! $(MAKE) -C $$i ; then \
                exit 1 ; \
            fi ; \
        done

.PHONY: buildmore
buildmore:
	for i in $(DIRS) $(MOREDIRS) ; do \
            if ! $(MAKE) -C $$i ; then \
                exit 1 ; \
            fi ; \
        done

.PHONY: install
install:
	for i in $(DIRS) ; do \
            if ! $(MAKE) -C $$i install ; then \
                exit 1 ; \
            fi ; \
        done

.PHONY: installmore
installmore:
	for i in $(DIRS) $(MOREDIRS) ; do \
            if ! $(MAKE) -C $$i install ; then \
                exit 1 ; \
            fi ; \
        done

.PHONY: clean
clean:
	for i in $(DIRS) $(MOREDIRS) ; do \
            if ! $(MAKE) -C $$i clean ; then \
                exit 1 ; \
            fi ; \
        done

#
# End of Makefile
#

=== external_functions/extrema/Makefile ===
#
# Makefile for Ferret External Functions
#
# January 20 1998
# Jonathan Callahan
#
#  15-Nov-1999 Ansley Manke
#  remove refs to ef_utility/*.o  (now in ferret executable)
# *sh* 2/2000 - removed SAMPLEIJ from target list (replaced by SAMPLEXY)
#
# ACM 2/2001  debug macros

#
# include site specific macro definitions
#
include ../ef_utility/site_specific.mk
 
#
# include platform specific macro definitions
#
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)

#
# Macros
#

.SUFFIXES: .so

#
# Rules
#

.F.o:
	$(FC) $(FFLAGS) -c $<

.F.so:
	$(FC) $(FFLAGS) -c $<
	$(LD) $(LD_DYN_FLAGS) $*.o minminmax.o maxminmax.o $(SYSLIBS) -o $*.so

#
# Targets
#

# all:    minminmax.o maxminmax.o findhi.so findlo.so
all:

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) $(FFLAGS_DEBUG)" "CFLAGS = $(CFLAGS) $(CFLAGS_DEBUG)" all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== external_functions/pnpoly/Makefile ===
#
# Makefile for Ferret External Functions
#

#
# include site specific macro definitions
#
include ../ef_utility/site_specific.mk

#
# include platform specific macro definitions
#
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)

#
# Macros
#

.SUFFIXES: .so

SUB_OBJS = pnpoly_subs.o

#
# Rules
#

.F.so:
	$(FC) $(FFLAGS) -c $<
	$(LD) $(LD_DYN_FLAGS) $(SUB_OBJS) $*.o $(SYSLIBS) -o $*.so

.c.o:
	$(CC) $(CFLAGS) -c $<

.F.o:
	$(FC) $(FFLAGS) -c $<

#
# Targets
#

#all:	pnpoly_subs.o pt_in_poly.so pt_in_poly_curvi.so
all:	pnpoly_subs.o pt_in_poly.so

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) $(FFLAGS_DEBUG)" "CFLAGS = $(CFLAGS) $(CFLAGS_DEBUG)" all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== external_functions/zaxr/Makefile ===
#
# Makefile for Ferret External Functions
#
# January 20 1998
# Jonathan Callahan
#
#  15-Nov-1999 Ansley Manke
#  remove refs to ef_utility/*.o  (now in ferret executable)
#
#  ACM 2/2001  debug macros

#
# include site specific macro definitions
#
include ../ef_utility/site_specific.mk

#
# include platform specific macro definitions
#
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)

#
# Macros
#

.SUFFIXES: .so

#
# Rules
#

.F.so:
	$(FC) $(FFLAGS) -c $<
	$(LD) $(LD_DYN_FLAGS) $*.o $(SYSLIBS) -o $*.so

#
# Targets
#

# all:	zaxreplace_avg.so zaxreplace_bin.so zaxreplace_lin.so zaxreplace_zlev.so zaxreplace_rev.so
all:	zaxreplace_xyt.so zaxreplace_lin.so eaxreplace_lin.so taxreplace_lin.so 

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) $(FFLAGS_DEBUG)" "CFLAGS = $(CFLAGS) $(CFLAGS_DEBUG)" all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== fer/pyf/Makefile ===
#
# Site-specific defines
#
include ../../site_specific.mk

#
# include platform specific definitions of:
#       CC, FC, RANLIB, CFLAGS, FFLAGS, PPLUS_FFLAGS
#
include ../../platform_specific.mk.$(BUILDTYPE)

include ./SOURCE_FILES
include ./LIB_NAME

#
# Macros
#

OBJS = $(SRCS_F:.F=.o)


#
# Targets
#

all:	$(LIB)

$(LIB): $(OBJS)
	$(AR) $(ARFLAGS) $@ $(OBJS)
	$(RANLIB) $@

clean:
	rm -f *.o $(LIB)

#
# End of Makefile
#

=== fmt/src/Makefile ===
# make TMAP library
# ver 0.0 3/14/91 *sh*  NOAA/PMEL/TMAP
# ver 0.1 10/11/91 kob  Jisao/pmel/tmap
# ver 1.0 2/3/93  *kob*
#        whole makefile revamped to implement recursive makes
# 10/27/94 *sh* changes for AIX: include -Dsun on the pre-processor pass
# define variables
# 8/22/95 - *kob* only have tmap_lib now, for both debug and non-debug
# 12/20/95 - # ifdef NINT_WRITE_UNMATCH added
#             to the routine TM_FMT.
#	     For now we should **not** use NINT_WRITE_UNMATCH during
#	     compilation anywhere -- the code that needed it was
#            applicable to VAX FORTRAN.  However, if we see odd
#            behavior from TM_FMT in the future we may need to use
#            D=NINT_WRITE_UNMATCH.
# 6/28/96  - *kob*  modify linux entry for an actual linux machine
#		    with fortran
# 11/12/96 - *kob* - modify makefile so by default it will create both a
#		   - non-debug and debug version of the tmap libray
# 11/14/96 - *kob* - Add Linux entry similar to that of AIX - linux f77
#		     doesn't use pre-processor
# 08/19/97 - *kob* - added "-Dreclen_in_bytes" to aix flags
# 06/05/12 - *kms* - change name to libtmap.a to simplify linking

include ../../site_specific.mk
include ../../platform_specific.mk.$(BUILDTYPE)
include ./SOURCE_FILES
include ./LIB_NAME

OBJS= $(SRCS_F:.F=.o) $(SRCS_C:.c=.o)

$(LIB): $(OBJS)
	ar r $(LIB) $(OBJS)
	$(RANLIB) $(LIB)

clean:
	rm -f *.o $(LIB)

=== debian/changelog ===
pyferret (7.6.3-3) unstable; urgency=medium

  [ Sebastien Bacher ]
  * debian/tests/control:
    - Build-Depends on python3-all since the tests try to import for all
      supported python versions and not only the current one
      Closes: #975246

  [ Alastair McKinstry ]
  * standards-Version: 4.5.1

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 21 Nov 2020 15:26:15 +0000

pyferret (7.6.3-2) unstable; urgency=medium

  * Update d/not-installed to work with python3.9. Closes: #972430, #972347
  * Minor fixes to d/copyright syntax
  * Include missing files in d/missing (from git HEAD):
    - load_dsg_mask_ftrset_var.F
    - disp_data_set_up.F
    - dsg_traj_alongxy_setup.F
    - tm_dsg_ftrset_facts.F
    - plot_vs_set_up.F
    - make_dsg_ftrset_mask.F
    - reload_dsg_ftrmaskvar.F
    - dsg_pltalong_setup.F
    - make_dsg_feature_mask_dirs.F 

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 17 Oct 2020 08:52:39 +0100

pyferret (7.6.3-1) unstable; urgency=medium

  * New upstream release
  * Move to debhelper compat 13
  * Use d/gpb.conf to label DEP-14 branches; debian/ upstream /latest
  * Some files are no longer present ; path to remove from SOURCE_FILES
  * Add d/not-installed to document files not expected to be installed;
    ensure all ext_func/pylibs/* are installed

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 26 Sep 2020 12:23:22 +0100

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,13 @@
 Source: pyferret
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Homepage: https://ferret.pmel.noaa.gov/Ferret/documentation/pyferret
 Vcs-Browser: https://salsa.debian.org:/science-team/pyferret
-Vcs-Git: https://salsa.debian.org:/science-team/pyferret.git
+Vcs-Git: https://salsa.debian.org:/science-team/pyferret.git -b debian/latest
 Maintainer: Alastair McKinstry <mckinstry@debian.org>
 Section: science
 Priority: optional
 X-Python3-Version: >= 3.6
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
  dh-sequence-python3,
  gfortran | fortran-compiler,
  pkg-config,

=== debian/tests/control ===
--- 
+++ 
@@ -4,4 +4,4 @@
  ; echo "Testing with $py:"
  ; $py -c "import pyferret"
  ; done
-Depends: python3-ferret
+Depends: python3-ferret, python3-all

## pyferret 7.6.5

=== Makefile ===
#
# Makefile for building and installing the pyferret module
# and the modules and libraries associated with it.
#

# Site-specific defines
include site_specific.mk

# Platform-specific defines
include platform_specific.mk.$(BUILDTYPE)

ifeq ("$(BUILDTYPE)", "intel-mac")
	COPY_DYLIBS = - ( cd $(DIR_PREFIX); ./copy_dylibs.sh )
else
	COPY_DYLIBS =
endif

.PHONY : all
all : optimized

.PHONY : optimized
optimized :
	mkdir -p $(DIR_PREFIX)/lib
	$(COPY_DYLIBS)
	$(MAKE) -C $(DIR_PREFIX)/fer optimized
	$(MAKE) pymod_optimized_build
	$(MAKE) pymod_optimized_install
	$(MAKE) externals_optimized
	$(MAKE) -C $(DIR_PREFIX)/bin/build_fonts/unix

.PHONY : debug
debug :
	mkdir -p $(DIR_PREFIX)/lib
	$(COPY_DYLIBS)
	$(MAKE) -C $(DIR_PREFIX)/fer debug
	$(MAKE) pymod_debug_build
	$(MAKE) pymod_debug_install
	$(MAKE) externals_debug
	$(MAKE) -C $(DIR_PREFIX)/bin/build_fonts/unix

## The definition of MEMORYDEBUG is observed by fer/special/FerMem_routines.c,
## which causes it to print (append) all memory allocations, reallocations,
## and frees to file "memorydebug.txt".  Initialize allocated memory with
## non-zero values.  Expect this to be a lot slower due to all the
## (intentionally inefficient but safe) file operations.
.PHONY : memorydebug
memorydebug :
	mkdir -p $(DIR_PREFIX)/lib
	$(COPY_DYLIBS)
	$(MAKE) -C $(DIR_PREFIX)/fer memorydebug
	$(MAKE) "CFLAGS = $(CFLAGS) -DMEMORYDEBUG" pymod_debug_build
	$(MAKE) "CFLAGS = $(CFLAGS) -DMEMORYDEBUG" pymod_debug_install
	$(MAKE) externals_debug
	$(MAKE) -C $(DIR_PREFIX)/bin/build_fonts/unix

## The following defines GRDELDEBUG used by fer/grdel, which causes it
## to create a grdeldebug.log file with all the graphics commands issued
.PHONY : grdeldebug
grdeldebug :
	mkdir -p $(DIR_PREFIX)/lib
	$(COPY_DYLIBS)
	$(MAKE) -C $(DIR_PREFIX)/fer grdeldebug
	$(MAKE) pymod_debug_build
	$(MAKE) pymod_debug_install
	$(MAKE) externals_debug
	$(MAKE) -C $(DIR_PREFIX)/bin/build_fonts/unix

## The following does an optimized build of libpyferret.so
.PHONY : pymod_optimized_build
pymod_optimized_build :
	rm -fr $(DIR_PREFIX)/build $(DIR_PREFIX)/install
	( cd $(DIR_PREFIX) ; \
	  export CC=$(CC) ; \
	  export CFLAGS="$(CFLAGS) -DNDEBUG -O" ; \
	  export BUILDTYPE=$(BUILDTYPE) ; \
	  export NETCDF_LIBDIR=$(NETCDF_LIBDIR) ; \
	  export HDF5_LIBDIR=$(HDF5_LIBDIR) ; \
	  export SZ_LIBDIR=$(SZ_LIBDIR) ; \
	  export CAIRO_LIBDIR=$(CAIRO_LIBDIR) ; \
	  export PIXMAN_LIBDIR=$(PIXMAN_LIBDIR) ; \
	  export PANGO_LIBDIR=$(PANGO_LIBDIR) ; \
	  export GLIB2_LIBDIR=$(GLIB2_LIBDIR) ; \
	  export GFORTRAN_LIB=$(GFORTRAN_LIB) ; \
	  export BIND_AND_HIDE_INTERNAL=$(BIND_AND_HIDE_INTERNAL) ; \
	  $(PYTHON_EXE) setup.py --quiet build )

## The following installs libpyferret.so and optimized
## versions of all the python scripts into $(DIR_PREFIX)/install.
.PHONY : pymod_optimized_install
pymod_optimized_install :
	rm -fr $(DIR_PREFIX)/install
	( cd $(DIR_PREFIX) ; \
	  export CC=$(CC) ; \
	  export CFLAGS="$(CFLAGS) -DNDEBUG -O" ; \
	  export BUILDTYPE=$(BUILDTYPE) ; \
	  export NETCDF_LIBDIR=$(NETCDF_LIBDIR) ; \
	  export HDF5_LIBDIR=$(HDF5_LIBDIR) ; \
	  export SZ_LIBDIR=$(SZ_LIBDIR) ; \
	  export CAIRO_LIBDIR=$(CAIRO_LIBDIR) ; \
	  export PIXMAN_LIBDIR=$(PIXMAN_LIBDIR) ; \
	  export PANGO_LIBDIR=$(PANGO_LIBDIR) ; \
	  export GLIB2_LIBDIR=$(GLIB2_LIBDIR) ; \
	  export GFORTRAN_LIB=$(GFORTRAN_LIB) ; \
	  export BIND_AND_HIDE_INTERNAL=$(BIND_AND_HIDE_INTERNAL) ; \
	  $(PYTHON_EXE) setup.py --quiet install -O2 --prefix=$(DIR_PREFIX)/install )

.PHONY : externals_optimized
externals_optimized :
	$(MAKE) "FER_DIR = $(DIR_PREFIX)/install" -C $(DIR_PREFIX)/external_functions optimized

## The following does a debug build of libpyferret.so
.PHONY : pymod_debug_build
pymod_debug_build :
	rm -fr $(DIR_PREFIX)/build $(DIR_PREFIX)/install
	( cd $(DIR_PREFIX) ; \
	  export CC=$(CC) ; \
	  export CFLAGS="$(CFLAGS) -UNDEBUG -O0 -g" ; \
	  export BUILDTYPE=$(BUILDTYPE) ; \
	  export NETCDF_LIBDIR=$(NETCDF_LIBDIR) ; \
	  export HDF5_LIBDIR=$(HDF5_LIBDIR) ; \
	  export SZ_LIBDIR=$(SZ_LIBDIR) ; \
	  export CAIRO_LIBDIR=$(CAIRO_LIBDIR) ; \
	  export PIXMAN_LIBDIR=$(PIXMAN_LIBDIR) ; \
	  export PANGO_LIBDIR=$(PANGO_LIBDIR) ; \
	  export GLIB2_LIBDIR=$(GLIB2_LIBDIR) ; \
	  export GFORTRAN_LIB=$(GFORTRAN_LIB) ; \
	  export BIND_AND_HIDE_INTERNAL=$(BIND_AND_HIDE_INTERNAL) ; \
	  $(PYTHON_EXE) setup.py build -g )

## The following installs libpyferret.so and unoptimized
## versions of all the python scripts into $(DIR_PREFIX)/install.
.PHONY : pymod_debug_install
pymod_debug_install :
	rm -fr $(DIR_PREFIX)/install
	( cd $(DIR_PREFIX) ; \
	  export CC=$(CC) ; \
	  export CFLAGS="$(CFLAGS) -UNDEBUG -O0 -g" ; \
	  export BUILDTYPE=$(BUILDTYPE) ; \
	  export NETCDF_LIBDIR=$(NETCDF_LIBDIR) ; \
	  export HDF5_LIBDIR=$(HDF5_LIBDIR) ; \
	  export SZ_LIBDIR=$(SZ_LIBDIR) ; \
	  export CAIRO_LIBDIR=$(CAIRO_LIBDIR) ; \
	  export PIXMAN_LIBDIR=$(PIXMAN_LIBDIR) ; \
	  export PANGO_LIBDIR=$(PANGO_LIBDIR) ; \
	  export GLIB2_LIBDIR=$(GLIB2_LIBDIR) ; \
	  export GFORTRAN_LIB=$(GFORTRAN_LIB) ; \
	  export BIND_AND_HIDE_INTERNAL=$(BIND_AND_HIDE_INTERNAL) ; \
	  $(PYTHON_EXE) setup.py --quiet install -O0 --prefix=$(DIR_PREFIX)/install )

.PHONY : externals_debug
externals_debug :
	$(MAKE) "FER_DIR = $(DIR_PREFIX)/install" -C $(DIR_PREFIX)/external_functions debug

## Remove everything that was built
.PHONY : clean
clean :
#	$(MAKE) -C $(DIR_PREFIX)/bench clean
	$(MAKE) -C $(DIR_PREFIX)/bin/build_fonts/unix clean
	$(MAKE) -C $(DIR_PREFIX)/external_functions clean
	rm -fr $(DIR_PREFIX)/install $(DIR_PREFIX)/build ferret.jnl*
	find $(DIR_PREFIX)/pviewmod -name '*.py[co]' -delete
	find $(DIR_PREFIX)/pyfermod -name '*.py[co]' -delete
	$(MAKE) -C $(DIR_PREFIX)/fer clean
	rm -fr $(DIR_PREFIX)/lib $(DIR_PREFIX)/dylibs

## Install Ferret binaries, scripts, and other files into $(INSTALL_FER_DIR)
.PHONY : install
install :
	rm -f pyferret-latest-local.tar.gz
	bin/make_dist_tar . latest local . -y
	mkdir -p $(INSTALL_FER_DIR)
	mv -f pyferret-latest-local.tar.gz $(INSTALL_FER_DIR)
	( cd $(INSTALL_FER_DIR) ; tar xz --strip-components=1 -f pyferret-latest-local.tar.gz )

## The following is for installing the updated ferret_ef_meme_subsc.so, libpyferret.so,
## and PyFerret python scripts into $(INSTALL_FER_DIR)/lib without having to use the
## distribution tar file.  Also copies all the PyFerret Fortran external function to
## the $(INSTALL_FER_DIR)/ext_func/pylibs directory.
.PHONY : update
update :
	mkdir -p $(INSTALL_FER_DIR)/lib
	find $(DIR_PREFIX)/external_functions -type f -perm -100 -name \*.so -exec cp {} $(INSTALL_FER_DIR)/ext_func/pylibs \;
	( cd $(DIR_PREFIX) ; \
	  export CC=$(CC) ; \
	  export CFLAGS="$(CFLAGS) -O" ; \
	  export BUILDTYPE=$(BUILDTYPE) ; \
	  export NETCDF_LIBDIR=$(NETCDF_LIBDIR) ; \
	  export HDF5_LIBDIR=$(HDF5_LIBDIR) ; \
	  export SZ_LIBDIR=$(SZ_LIBDIR) ; \
	  export CAIRO_LIBDIR=$(CAIRO_LIBDIR) ; \
	  export PIXMAN_LIBDIR=$(PIXMAN_LIBDIR) ; \
	  export PANGO_LIBDIR=$(PANGO_LIBDIR) ; \
	  export GLIB2_LIBDIR=$(GLIB2_LIBDIR) ; \
	  export GFORTRAN_LIB=$(GFORTRAN_LIB) ; \
	  export BIND_AND_HIDE_INTERNAL=$(BIND_AND_HIDE_INTERNAL) ; \
	  $(PYTHON_EXE) setup.py --quiet install -O2 --prefix=$(INSTALL_FER_DIR) )

## Compare results from executing the RUN_TESTS.sh test suite with those saved under bench/test_results
.PHONY : check
check :
	$(MAKE) -C $(DIR_PREFIX)/bench check

.PHONY : check_noremote
check_noremote :
	$(MAKE) -C $(DIR_PREFIX)/bench check_noremote

##

=== bench/Makefile ===
#
# Makefile for the PyFerret bench subdirectory
#

# include platform specific macro definitions for make_stream_file
include ../site_specific.mk
include ../platform_specific.mk.$(BUILDTYPE)

## Run all the benchmark tests, including those requiring remote data
## (environment variable SKIP_REMOTE is empty)
.PHONY: check
check:
	@$(MAKE) "SKIP_REMOTE=" run_tests
	@$(MAKE) "SKIP_REMOTE=" compare_plots
	@$(MAKE) "SKIP_REMOTE=" compare_logs

## Run all the benchmark tests except those requiring remote data
## (environment variable SKIP_REMOTE is not empty)
.PHONY: check_noremote
check_noremote:
	@$(MAKE) "SKIP_REMOTE=XXXX" run_tests
	@$(MAKE) "SKIP_REMOTE=XXXX" compare_plots
	@$(MAKE) "SKIP_REMOTE=XXXX" compare_logs

## Execute the RUN_TESTS.sh test suite
## If the environment variable SKIP_REMOTE is not empty, skips tests requiring remote data
.PHONY: run_tests
run_tests:
	@( \
	    ferret_exe=`which pyferret` ;\
	    if [ $$ferret_exe = "" -o "$(FER_DIR)" = "" ] ; then \
	        echo "*** PyFerret must be installed and the ferret_paths script must have sourced for these tests ***" ;\
	        exit 1 ;\
	    fi ;\
	    echo "Using $$ferret_exe" ;\
	    SED_EXTREGEX_FLAG="$(SED_EXTREGEX_FLAG)" ;\
	    export SED_EXTREGEX_FLAG ;\
	    ./RUN_TESTS.sh $$ferret_exe "$(PYFER_EXTERNAL_FUNCTIONS)" \
	)

## Compare the plots from executing the RUN_TESTS.sh test suite with those saved.
## If the environment variable SKIP_REMOTE is empty, compares to those under "test_result";
## otherwise compares to those under "test_results_noremote"
.PHONY: compare_plots
compare_plots:
	-@( \
	    if [ -z "$(SKIP_REMOTE)" ] ; then \
	        results_dir="test_results" ;\
	    else \
	        results_dir="test_results_noremote" ;\
	    fi ;\
	    echo "Comparing PNG and PDF files to those in bench/$$results_dir" ;\
	    for img in `find . -name '*.p[nd][gf]' -a \! -regex '.*_diff.png' -exec basename {} \; | sort -u` ; do \
	        if [ ! -f $$img ] ; then \
	            echo "****** File $$img is missing ******" ;\
	        elif [ ! -f $$results_dir/$$img ] ; then \
	            echo "****** File $$results_dir/$$img is missing ******" ;\
	        elif diff -q $$img $$results_dir/$$img 1> /dev/null ; then \
	            echo "(Files $$img and $$results_dir/$$img are identical)" ;\
	        else \
	            numdiffpix=`compare -quiet -metric AE $$img $$results_dir/$$img $${img}_diff.png 2>&1` ;\
	            if [ "$$numdiffpix" = "0" ] ; then \
	                rm -f $${img}_diff.png ;\
	                echo "(Images $$img and $$results_dir/$$img are identical)" ;\
	            else \
	                echo "****** Images $$img and $$results_dir/$$img are different ******" ;\
	            fi ;\
	        fi ;\
	    done \
	)
	@echo ''
	@echo 'Inspect the *_diff.png files for actual differences in the images'
	@echo ''

## Compare the log, err, and ncdump results from executing the RUN_TESTS.sh test suite.
## If the environment variable SKIP_REMOTE is empty, compares to those under "test_result";
## otherwise compares to those under "test_results_noremote"
.PHONY: compare_logs
compare_logs:
	-@( \
	    if [ -z "$(SKIP_REMOTE)" ] ; then \
	        results_dir="test_results" ;\
	    else \
	        results_dir="test_results_noremote" ;\
	    fi ;\
	    datetag=`date +'%d%h%yAT'|tr '[A-Z]' '[a-z]'` ;\
	    logfile=`/bin/ls -1 all_$${datetag}*_log` ;\
	    if [ -z "$$logfile" ] ; then \
	        echo "*** No run_tests results log file from today found ***" ;\
	        exit 1 ;\
	    fi ;\
	    if [ `echo "$${logfile[@]}" | wc -l` -ne 1 ] ; then \
	        echo "*** Multiple run_tests results logs from today found ***" ;\
	        exit 1 ;\
	    fi ;\
	    echo "Comparing $$logfile to bench/$$results_dir/pyferret_run_tests_log" ;\
	    diff $$logfile $$results_dir/pyferret_run_tests_log 1> pyferret_run_tests_log.diff 2>&1 ;\
	    errfile=`echo $$logfile | sed -e "s%log%err%"` ;\
	    echo "Comparing $$errfile to bench/$$results_dir/pyferret_run_tests_err" ;\
	    diff $$errfile $$results_dir/pyferret_run_tests_err 1> pyferret_run_tests_err.diff 2>&1 ;\
	    ncdfile=`echo $$logfile | sed -e "s%log%ncdump%"` ;\
	    echo "Comparing $$ncdfile to bench/$$results_dir/pyferret_run_tests_ncdump" ;\
	    diff $$ncdfile $$results_dir/pyferret_run_tests_ncdump 1> pyferret_run_tests_ncdump.diff 2>&1 ;\
	    echo '' ;\
	    echo 'Inspect the pyferret_run_tests_*.diff files for actual differences in the output' \
	)
	@echo ''

.PHONY: clean
clean:
	rm -f all_*_ncdump all_*_err all_*_log all_*_ncdump_orig all_*_err_orig all_*_log_orig cleanups.sed
	rm -f *.ps* *.eps* *.png* *.pdf* *.diff* ferret.jnl*
	rm -f `cat TRASH_FILES`
	rm -f all_ncdump.out fort.41 make_stream_file
	rm -fr subdir tmp aggf

make_stream_file: make_stream_file.F
	$(FC) $(FFLAGS) make_stream_file.F -o make_stream_file

#
# End of Makefile
#

=== ppl/Makefile ===
#
# include platform specific definitions of:
#       CC, FC, RANLIB, CFLAGS, FFLAGS, PPLUS_FFLAGS
#

include ../site_specific.mk
include ../platform_specific.mk.$(BUILDTYPE)

DIRS	= tmapadds complot ourlib plot \
	  plotlib pplepic pplusr symlib

# change the standard rules for .F -> .o builds so $(PPLUS_FFLAGS) is used
# Directly compile the .F source files to the .o object files
# since gfortran can handle the C compiler directives in Fortran code
%.o : %.F
	$(FC) $(PPLUS_FFLAGS) -c $*.F -o $*.o

#
# Targets
#

all:
	for i in $(DIRS) ; do \
            if ! $(MAKE) -C $$i ; then \
                exit 1 ; \
            fi ; \
        done


clean:
	for i in $(DIRS) ; do \
            $(MAKE) -C $$i clean ; \
        done

#
# End of Makefile
#

=== external_functions/fft/Makefile ===
#
# Makefile for Ferret External Functions
#
# January 20 1998
# Jonathan Callahan
# Ansley Manke: compile subroutines separately w/ fewer flags.
#
#  15-Nov-1999 Ansley Manke
#  remove refs to ef_utility/*.o  (now in ferret executable)
#
# 2/2001  debug macros
# 1/2002  need $(FC) in .F.so rule
#         and compile ffta_sample, fftp_sample functions
# 7/2012  Do not need a special platform_specific file.

#
# include site specific macro definitions
#
include ../ef_utility/site_specific.mk

#
# include platform specific macro definitions
#
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)


#
# Macros
#

.SUFFIXES: .so

SUB_OBJS = fftinv_subs.o fftsubs.o

#
# Rules
#

.F.so:
	$(FC) $(FFLAGS) -c $<
	$(LD) $(LD_DYN_FLAGS) $(SUB_OBJS) $*.o $(SYSLIBS) -o $*.so

#
# Targets
#

all:	fftinv_subs.o fftsubs.o fft_amp.so fft_phas.so ffta_sample.so

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) $(FFLAGS_DEBUG)" "CFLAGS = $(CFLAGS) $(CFLAGS_DEBUG)" all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== external_functions/gridding/Makefile ===
#
# Makefile for Ferret External Functions
#
# January 20 1998
# Jonathan Callahan
#
#  15-Nov-1999 Ansley Manke
#  remove refs to ef_utility/*.o  (now in ferret executable)
#
# ACM 2/2001  debug macros

#
# include site specific macro definitions
#
include ../ef_utility/site_specific.mk

#
# include platform specific macro definitions
#
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)

#
# Macros
#

.SUFFIXES: .so
SUB_OBJS = modscatminmax.o nobsxytv.o scat2grid_subs_mask.o
#SUB_OBJS = scat2grid_subs.o

#
# Rules
#

.F.so:
	$(FC) $(FFLAGS) -c  $<
	$(LD) $(LD_DYN_FLAGS) $(SUB_OBJS) $*.o $(SYSLIBS) -o $*.so

.F.o:
	$(FC) $(FFLAGS) -c  $<

#
# Targets
#

all:	$(SUB_OBJS) tracks2grid_std_xyt.so scat2grid_std_xyt.so \
	scat2grid_minmax_xyt.so scat2grid_mask_bin_xyt.so scat2grid_mask_minmax_xyt.so \
	scat2grid_mask_nbin_xyt.so scat2grid_mask_std_xyt.so tracks2grid_mask_ave_xyt.so

#all:	$(SUB_OBJS) index_to_grid.so scat2grid_nobs_xy.so

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) -g -Ddebug" "CFLAGS = $(CFLAGS) -g -Ddebug"  all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== external_functions/hinterp/Makefile ===
#
# Makefile for Ferret External Functions
#
# January 20 1998
# Jonathan Callahan
#
#  15-Nov-1999 Ansley Manke
#  remove refs to ef_utility/*.o  (now in ferret executable)
#
#  ACM 2/2001  debug macros
#  ACM 2/2002  change targets to all and extras; somehow standard
#               not working well w/ linux.

#
# include site specific macro definitions
#
include ../ef_utility/site_specific.mk

#
# include platform specific macro definitions
#
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)

#
# Macros
#

.SUFFIXES: .so

#
# Rules
#

.F.so:
	$(FC) $(FFLAGS) -c $<
	$(LD) $(LD_DYN_FLAGS) $*.o $(SYSLIBS) -o $*.so

.c.o:
	$(CC) $(CFLAGS) -c $<

.F.o:
	$(FC) $(FFLAGS) -c $<

#
# Targets
#

# all:	rect_to_curv.so curv_to_rect_map.so curv_to_rect.so curv_range.so
all:	curv_to_rect_fsu.so

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) $(FFLAGS_DEBUG)" "CFLAGS = $(CFLAGS) $(CFLAGS_DEBUG)" all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== external_functions/lanczos/Makefile ===
#
# Makefile for Ferret External Functions
#
# lanczos function from Brett McDaniel was in
# Fortran 90.  Translated to f77 by Ansley Manke  6/25/04
#
#  remove refs to ef_utility/*.o  (now in ferret executable)

#
# include site specific macro definitions
#
include ../ef_utility/site_specific.mk

#
# include platform specific macro definitions
#
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)

#
# Macros
#

.SUFFIXES: .so

#
# Rules
#

.F.so:
	$(FC) $(FFLAGS) -c $<
	$(LD) $(LD_DYN_FLAGS) $*.o $(SYSLIBS) -o $*.so

#
# Targets
#

# all:    lanczos.so
all:

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) $(FFLAGS_DEBUG)" "CFLAGS = $(CFLAGS) $(CFLAGS_DEBUG)" all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== external_functions/las/Makefile ===
#
# Makefile for Ferret External Functions
#
# January 20 1998
# Jonathan Callahan
#
#  15-Nov-1999 Ansley Manke
#  remove refs to ef_utility/*.o  (now in ferret executable)
#
#  ACM 2/2001  debug macros
#  ACM 2/2002  change targets to all and extras; somehow standard
#               not working well w/ linux.

#
# include site specific macro definitions
#
include ../ef_utility/site_specific.mk

#
# include platform specific macro definitions
#
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)

#
# Macros
#

.SUFFIXES: .so

#
# Rules
#

.F.so:
	$(FC) $(FFLAGS) -c $<
	$(LD) $(LD_DYN_FLAGS) $*.o $(SYSLIBS) -o $*.so

.c.o:
	$(CC) $(CFLAGS) -c $<

.F.o:
	$(FC) $(FFLAGS) -c $<

#
# Targets
#

#all:	write_webrow.so write_webrow_gwt.so list_value_xml.so lon_lat_time_string.so
all:

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) $(FFLAGS_DEBUG)" "CFLAGS = $(CFLAGS) $(CFLAGS_DEBUG)" all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== external_functions/matlab/Makefile ===
#
# Makefile (for FERRET/fer/efi statically linked EF code)
#
# Feb 28, 2000  -- based on other TMAP external functions makefiles
# Ansley Manke
# Jonathan Callahan (with some help from Joe Sirott)
#
# *acm* 3/23/2000 link  ../common to ferret_cmn  rather than using the
#       link in ef_utility (which may not be present when this is compiled.)
#  ACM  2/2001  debug macros
#
#  Note that these functions must be decleared in ../ccr/EF_InternalUtil.c
#  Run the perl script in this directory int_dlsym.pl ./ > intcode.c
#  put the resulting lines in three places in EF_InternalUtil.c as
#  noted in the comments at the start of that file.

#
# include site specific macro definitions
#
include ../ef_utility/site_specific.mk

#
# include platform specific macro definitions
#
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)

#
# Matlab specific. Only works for Solaris cc and f77 compiler
# Dependent on location of MATLAB installation
#
MATLAB_INCLUDES=-I/opt/local/matlab/matlab5.2/extern/include
MATLAB_DIR=/opt/local/matlab/matlab5.2/extern/lib/sol2
MATLAB_LIBS=$(MATLAB_DIR)/libeng.so $(MATLAB_DIR)/libmat.so
CFLAGS += $(MATLAB_INCLUDES) -K PIC
FFLAGS += -PIC

#
# Macros
#

OBJSF = $(SRCS_F:.F=.o)

#
# Targets
#

all:	matlab.so matlab_func.so

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) $(FFLAGS_DEBUG)" "CFLAGS = $(CFLAGS) $(CFLAGS_DEBUG)" all

clean:
	rm -f *.so *.o

matlab.so: matlab.o matlab_link.o
	$(LD) -L $(MATLAB_DIR) $(LD_DYN_FLAGS) matlab.o \
		matlab_link.o -leng -lmat $(SYSLIBS) -o matlab.so	

matlab_func.so: matlab_func.o matlab_func_link.o
	$(LD) -L $(MATLAB_DIR) $(LD_DYN_FLAGS) matlab_func.o \
		matlab_func_link.o -leng -lmat $(SYSLIBS) -o matlab_func.so

#
# End of Makefile
#

=== external_functions/ncedit/Makefile ===
#
# Makefile for Ferret External Functions
#
# January 20 1998
# Jonathan Callahan
#
#  15-Nov-1999 Ansley Manke
#  remove refs to ef_utility/*.o  (now in ferret executable)
#
#  ACM 2/2001  debug macros
#  ACM 2/2002  change targets to all and extras; somehow standard
#               not working well w/ linux.

#
# include site specific macro definitions
#
include ../ef_utility/site_specific.mk

#
# include platform specific macro definitions
#
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)

#
# Macros
#

.SUFFIXES: .so

#
# Rules
#

.F.so:
	$(FC) $(FFLAGS) -c $<
	$(LD) $(LD_DYN_FLAGS) $*.o $(SYSLIBS) -o $*.so

.F.o:
	$(FC) $(FFLAGS) -c $<

#
# Targets
#

all:	nco.so nco_attr.so

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) $(FFLAGS_DEBUG)" "CFLAGS = $(CFLAGS) $(CFLAGS_DEBUG)" all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== external_functions/romea/Makefile ===
#
# Makefile for Ferret External Functions
#
# January 20 1998
# Jonathan Callahan
#
#  15-Nov-1999 Ansley Manke
#  remove refs to ef_utility/*.o  (now in ferret executable)
#  ACM  2/2001  debug macros

#
# include site specific macro definitions
#
include ../ef_utility/site_specific.mk

#
# include platform specific macro definitions
#
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)

#
# Macros
#

.SUFFIXES: .so

SUB_OBJS = rr_density.o

#
# Rules
#

.F.so:
	$(FC) $(FFLAGS) -c $<
	$(LD) $(LD_DYN_FLAGS) $(SUB_OBJS) $*.o $(SYSLIBS) -o $*.so

#
# Targets
#

all:	rr_density.o ffta_2.so ffta_3.so ffta_sample.so fftabst.so rr_adv_sx.so rr_adv_sy.so rr_adv_sz.so rr_adv_tx.so rr_adv_ty.so rr_adv_tz.so rr_adv_umetric.so rr_adv_ux.so rr_adv_uy.so rr_adv_uz.so rr_adv_vmetric.so rr_adv_vx.so rr_adv_vy.so rr_adv_vz.so rr_av.so rr_cross_spectrum.so rr_cross_spectrum_abs.so rr_diff_sx.so rr_diff_sy.so rr_diff_sz.so rr_diff_tx.so rr_diff_ty.so rr_diff_tz.so rr_diff_umetric.so rr_diff_ux.so rr_diff_uy.so rr_diff_uz.so rr_diff_vmetric.so rr_diff_vx.so rr_diff_vy.so rr_diff_vz.so rr_dsdt.so rr_dtdt.so rr_dudt.so rr_dvdt.so rr_flux_sx.so rr_flux_sy.so rr_flux_sz.so rr_flux_tx.so rr_flux_ty.so rr_flux_tz.so rr_flux_ux.so rr_flux_uy.so rr_flux_uz.so rr_flux_vx.so rr_flux_vy.so rr_flux_vz.so rr_fv.so rr_geopotential_height.so rr_grad_pbc_u.so rr_grad_pbc_v.so rr_grad_ps_u.so rr_grad_ps_v.so rr_taux.so rr_tauy.so rr_uux_qiao.so rr_vuy_qiao.so rr_w_qiao.so rr_wuz_qiao.so 

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) $(FFLAGS_DEBUG)" "CFLAGS = $(CFLAGS) $(CFLAGS_DEBUG)" all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== external_functions/tax_times/Makefile ===
#
# Makefile for Ferret External Functions
#
# January 20 1998
# Jonathan Callahan
#
#  15-Nov-1999 Ansley Manke
#  remove refs to ef_utility/*.o  (now in ferret executable)

#
# include site specific macro definitions
#
include ../ef_utility/site_specific.mk

#
# include platform specific macro definitions
#
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)

#
# Macros
#

.SUFFIXES: .so

#
# Rules
#

.F.so:
	$(FC) $(FFLAGS) -c $<
	$(LD) $(LD_DYN_FLAGS) $*.o $(SYSLIBS) -o $*.so

#
# Targets
#

all:	tax_index_datestring.so

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) $(FFLAGS_DEBUG)" "CFLAGS = $(CFLAGS) $(CFLAGS_DEBUG)" all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== debian/changelog ===
pyferret (7.6.5-10) unstable; urgency=medium

  * Add support for gfortran-15. Closes: #1114278
  * Remove old-fsf-address-in-copyright-file
  * Standards-Version: 4.7.2
  * Add misc:Depends for python3-ferret

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 16 Sep 2025 05:44:41 +0100

pyferret (7.6.5-9) unstable; urgency=medium

  [ Bastian Germann ]
  * Drop X-Python3-Version

  [ Alexandre Detiste ]
  * add explicit build-dependency on python3-setuptools (Closes: #1080708)

  [ Alastair McKinstry ]
  * Fix for numpy2; thanks to Stuart Prescott. Closes: #1094373
  * Build-depend on python3-numpy-dev for dh_numpy3
  * Link external plugins against libc
  * Drop incorrect lintian overrides
  * Correct d/copyright filename errors, thanks Lintian

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 12 Feb 2025 12:02:58 +0000

pyferret (7.6.5-8) unstable; urgency=medium

  * Team upload
  * tests: Correct import name
  * Fix salsa URL
  * d/copyright: Fix obvious errors

  [ Stuart Prescott ]
  * Fix Maintainer/Uploaders to match Debian Science Team policy
  * Fix Python Qt dependencies (Closes: 1089961)

 -- Bastian Germann <bage@debian.org>  Fri, 17 Jan 2025 19:46:05 +0100

pyferret (7.6.5-7) UNRELEASED; urgency=medium

  * Standards-Version: 4.7.0
  * Add build-dep on python3-setuptools. Closes: #1080708
  * Move from pkg-config to pkgconf

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 23 Aug 2024 09:04:31 +0100

pyferret (7.6.5-6) unstable; urgency=medium

  [ Alastair McKinstry ]
  * Port to setuptools
  * Drop obsolete dep on python3-future. Closes: #1058862
  * Depend on fortran-mod >=  0.31 for correct FMODDIR
  * Add platform files to debian for gcc14
  * gcc14.patch: changes for missing declarations. Closes: #1058888

  [ Colin Watson ]
  * Fix Python build paths to work on more architectures (closes: #1058888).

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 07 Aug 2024 08:45:47 +0100

pyferret (7.6.5-5) unstable; urgency=medium

  * Ensure all python3 types are shipped. Closes: #1058030
  * Add fortran-support.mk makefile, start simplifcation
  * Drop patching files that were missing in 7.6.3
  * Include bash_completion file

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 14 Dec 2023 19:22:01 +0000

pyferret (7.6.5-4) unstable; urgency=medium

  * Drop workaround needed for 7.6.3 bug
  * Fix python paths for build system changes. Closes: #1054691

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 10 Nov 2023 10:51:48 +0000

pyferret (7.6.5-3) unstable; urgency=medium

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Fix broken Vcs URL.

  [ Alastair McKinstry ]
  * Add platform definition files for gfortran-13. Closes: #1037822
  * Change paths for python3.11	
  * Standards-Version: 4.6.2

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 20 Jun 2023 15:05:33 +0100

pyferret (7.6.5-2) unstable; urgency=medium

  * Add platform file for gfortran-12. Closes: #1013019
  * Standards-Version: 4.6.1; no changes required

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 25 Jul 2022 11:28:04 +0100

pyferret (7.6.5-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 13 Dec 2021 09:16:12 +0000

pyferret (7.6.5~beta-1) unstable; urgency=medium

  * New upstream release
  * Add dep on python3-qtpy. (LP: #1902527)
  * Standards-Version: 4.6.0
  * Tests marked as superficial. Closes: #974465
  * Fix d/watch file regexp for -beta extension
  * Fix formatting errors in d/copyright

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 26 Sep 2021 16:20:57 +0100

pyferret (7.6.4~beta-1) experimental; urgency=medium

  * New upstream release
  * Add platform file for gfortran-11. Closes: #984303
  * Also allow builds with libeditreadline-dev

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 27 May 2021 20:14:42 +0100

=== debian/control ===
Source: pyferret
Standards-Version: 4.7.2
Homepage: https://ferret.pmel.noaa.gov/Ferret/documentation/pyferret
Vcs-Browser: https://salsa.debian.org/science-team/pyferret
Vcs-Git: https://salsa.debian.org/science-team/pyferret.git -b debian/latest
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Alastair McKinstry <mckinstry@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
 dh-sequence-python3,
 dh-fortran-mod (>= 0.31),
 pkgconf,
 python3-setuptools,
 csh,
 libreadline-dev | libeditreadline-dev,
 libcurl4-openssl-dev | libcurl-dev,
 libncurses-dev,
 libnetcdf-dev (>= 4.3.0),
 libnetcdff-dev,
 libxpm-dev,
 libxt-dev,
 libcairo2-dev,
 libpango1.0-dev,
 python3-all-dev,
 python3-numpy,
 python3-setuptools,
 ferret-vis

Package: python3-ferret
Architecture: any
Section: python
Depends: ${shlibs:Depends}, ${misc:Depends}, 
 ferret-vis, ${python3:Depends}, python3-pyqt5, python3-pyqt5.qtsvg
Recommends: ferret-datasets, python3-scipy, python3-pyshp
Description: Python3 wrapper for the Ferret visualization and analysis environment,
 Ferret is an interactive computer visualization and analysis environment
 designed to meet the needs of oceanographers and meteorologists analyzing
 large and complex gridded data sets. It can transparently access extensive
 remote Internet data bases using OPeNDAP (formerly known as DODS)
 .
 This is the Python3 wrapper for Ferret

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

include /usr/share/debhelper/dh-fortran/fortran-support.mk

# magic debhelper rule
%:
	dh $@ 

# To aid reproducible builds
LC_ALL=C
export LC_ALL

ARCH:=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
PYTHON_PLATFORM:=$(shell python3 -c 'import sysconfig; print(sysconfig.get_platform())')
LIBDIR:=/usr/lib/$(ARCH)
INSTALLDIR:=$(CURDIR)/debian/tmp

# FORT_VER:=$(shell basename $(shell readlink /usr/bin/$(FC_DEFAULT)))
FORT_VER:=gfortran-15

PY3:=$(shell py3versions -s)

override_dh_auto_build:
	cp debian/platform_specific.mk.debian.$(FORT_VER) platform_specific.mk.debian
	cp debian/ef_utility/platform_specific.mk.debian.$(FORT_VER) external_functions/ef_utility/platform_specific.mk.debian
	sed -e 's%@ARCH@%${ARCH}%' \
		-e 's%@PYTHON@%${PY3}%' \
                -e 's%@LIBDIR@%${LIBDIR}%' \
		-e 's%@CURDIR@%${CURDIR}%' \
                -e 's%@INSTALLDIR@%${INSTALLDIR}%' \
                < debian/site_specific.mk.in > site_specific.mk
	cp site_specific.mk external_functions/ef_utility

override_dh_auto_install:
	# Build and install 
	# Horrible hack breaks The Debian Way. I'm doing the build in the 'install' phase, as i'm installing into debian/tmp
	# Doing it any earlier, and dh_prep will remove debian/tmp. 
	# This means I'm also doing 'test' after the Install, not between during make & install. gack.
	for p in $(PY3) ; do \
		mkdir -p $(INSTALLDIR)/lib/$$p ; \
		m=`echo $$p | tr -d 'python'  ` ; \
		n=`echo $$p | tr -d 'python' | tr -d '.' ` ; \
                ln -s  $(CURDIR)/build/lib.$(PYTHON_PLATFORM)-cpython-$$n/pyferret/libpyferret.cpython-$$n-$(ARCH).so \
                   $(INSTALLDIR)/lib/$$p/libpyferret.so ; \
		$(MAKE) HOSTTYPE=debian PYTHON_EXE=$$p INSTALLDIR=debian/tmp-$$p clean all install ; \
		cp $(CURDIR)/install/local/lib/$$p/dist-packages/pyferret-7.65-py$$m-$(PYTHON_PLATFORM).egg/pyferret/libpyferret.cpython-$$n-$(ARCH).so \
			$(INSTALLDIR)/lib/$$p ; \
		done
	find debian \( -name '*.pyo' -o -name '*.pyc' \) -delete
	find debian -type d -name __pycache__ -delete
	dh_numpy3
	@echo "Now doing bench tests"
	# ln -s debian/pyferret3  $(INSTALLDIR)/lib/$(shell py3versions -d)/pyferret
	# First build necessary files
	for p in  $(shell py3versions -d) ; do \
		sed -e 's%@ARCH@%${ARCH}%' \
                -e 's%@LIBDIR@%${LIBDIR}%' \
		-e 's%@CURDIR@%${CURDIR}%' \
                -e "s%@PYTHON@%$$p%" \
		-e 's%@INSTALLDIR@%${INSTALLDIR}%' \
                < debian/site_specific.mk.in > site_specific.mk ; \
		PATH=$(INSTALLDIR)/lib/$$p:$(PATH) PYTHONPATH=$(INSTALLDIR)/lib/$$p/site-packages \
		$(MAKE) HOSTTYPE=debian PYTHON_EXE=$$p INSTALLDIR=debian/tmp-$$p clean all install ; \
		done

override_dh_auto_test:
	@echo "Dummy test, to avoid calling make. Do test later"

override_dh_auto_clean:
	# use system xpm.h, not supplied ones
	rm -f fer/gui/xpm*.h
	rm -rf ./build ./install
	find . -type l  -delete 
	find . -name '*.o' -o -name '*.so'  -delete
	[ ! -f platform_specific_flags.mk.debian ]  || $(MAKE)  clean HOSTTYPE=debian

=== debian/tests/control ===
Test-Command: set -e
 ; for py in $(py3versions -r 2>/dev/null)
 ; do cd "$AUTOPKGTEST_TMP"
 ; echo "Testing with $py:"
 ; $py -c "import libpyferret"
 ; done
Depends: python3-ferret, python3-all
Restrictions: superficial

=== debian/watch ===
version=4
opts=uversionmangle=s/(-beta)/beta/;s/(rc|a|b|c)/~$1/,\
  filenamemangle=s/.+\/v?@ANY_VERSION@\.tar\.gz/PyFerret$1\.tar\.gz/ \
  https://github.com/NOAA-PMEL/PyFerret/tags .*\/v?@ANY_VERSION@.tar\.gz
